Forum:Lisp
Thema:Textstil von Mtext und Text ändern ohne Eigenschaftenfenster
Möchten Sie sich registrieren?
Wer darf antworten? Registrierte Benutzer können Beiträge verfassen.
Hinweise zur Registrierung Sie müssen registriert sein, um Beiträge oder Antworten auf Beiträge schreiben zu können.
Ihr Benutzername:
Ihr Kennwort:   Kennwort vergessen?
Anhang:    Datei(en) anhängen  <?>   Anhänge verwalten  <?>
Grafik für den Beitrag:                                                
                                                       
Ihre Antwort:

Fachbegriff
URL
Email
Fett
Kursiv
Durchgestr.
Liste
*
Bild
Zitat
Code

*HTML ist AUS
*UBB-Code ist AN
Smilies Legende
Netiquette

10 20 40

Optionen Smilies in diesem Beitrag deaktivieren.
Signatur anfügen: die Sie bei den Voreinstellungen angegeben haben.

Wenn Sie bereits registriert sind, aber Ihr Kennwort vergessen haben, klicken Sie bitte hier.

Bitte drücken Sie nicht mehrfach auf "Antwort speichern".

*Ist HTML- und/oder UBB-Code aktiviert, dann können Sie HTML und/oder UBB Code in Ihrem Beitrag verwenden.

T H E M A     A N S E H E N
Manuel486

Beiträge: 92 / 0

Windows 10 Pro - 64-Bit -
Lenovo Thinkstation P520 -
Intel Xeon W-2255 CPU @ 3.70 GHz 10 Kerne -
2x32GB DDR4 RAM @ 2933 MHz -
Samsung MZVLB512HAJQ-000L7 SSD 500GB -
Seagate ST1000DM003 HDD 1000GB -
NVIDIA Quadro P2200 5GB -
Elgato Stream Deck 15 Tasten -
AutoCAD MEP 2019 - Revit 2018+2019+2020

Guten morgen,

habe mal wieder eine lange suche hinter mir, aber finde nichts...
Ich möchte gerne Mtexte und danach auch Texte auf einen anderen Schriftstil legen lassen.

Es sollte wie folgt ablaufen Mtexte auswählen mit:
^C^C(sssetfirst nil (ssget "_X" '((0 . "MTEXT")(410 . "Model"))))

Jetzt habe ich gedacht der Befehl _textstyle hilft mir weiter.
Dieser Befehl setzt aber nur einen bestimmten Textstil aktuell.

Mit _change komme ich nicht weiter...
Gibt es denn keinen Befehl um das nicht von Hand machen zu müssen?

Der komplette Ablauf wäre:
-Mtexte auswählen
- auf Schriftstil ISOCP-1 legen
- Ursprung (_explode)
-Texte auswählen
- auf Schriftstil ISOCP-1 legen
- Breitenfaktor auf 0.8
FERTIG


MFG
Manuel486

CADmium

Beiträge: 13456 / 249

.

Ändere im Eigenschaftsfenster für die getätigte Auswahl Befehl: _properties    -- Ansonsten  -> kleines Lisp

------------------
Also ich finde Unities gut ... und andere sicher auch
---------------------------------------
  - Thomas -          
"Bei 99% aller Probleme ist die umfassende Beschreibung des Problems bereits mehr als die Hälfte der Lösung desselben."

Manuel486

Beiträge: 92 / 0

Windows 10 Pro - 64-Bit -
Lenovo Thinkstation P520 -
Intel Xeon W-2255 CPU @ 3.70 GHz 10 Kerne -
2x32GB DDR4 RAM @ 2933 MHz -
Samsung MZVLB512HAJQ-000L7 SSD 500GB -
Seagate ST1000DM003 HDD 1000GB -
NVIDIA Quadro P2200 5GB -
Elgato Stream Deck 15 Tasten -
AutoCAD MEP 2019 - Revit 2018+2019+2020

Ich will es ja gerade NICHT mit dem Eigenschaftenfenster machen.
Der Befehl _properties öffnet ja nur das Eigenschaftenfenster,
oder verstehe ich hier was falsch ?!
Meldin

Beiträge: 336 / 0

ACA2018
Windows10

Also ich denke jetzt nur mal laut 
Anhand der Menge an Beiträgen die du in der kurzen Zeit hier aufgemacht hast und vor allem das du das alles immer in ein Befehlsscript packen möchtest.
Mehr an Unhandlichkeit geht einfach nicht; keine Fehlerkorrektur; keine Ablaufverfolgung und und und. Es ist und bleibt ein basteln was du da machst. Aufgrund des Umfangs deiner Abläufe würde ich dir davon abraten. Ein oder 2 Befehle aufrufen wäre noch OK alles andere erinnert an den Kampf der Leute die nur die LT Version besitzen und versuchen sich mit solchen Buttons etwas Erleichterung zu verschaffen. Und da lehne ich mich jetzt mal aus dem Fenster und würde sagen keiner der hier ein paar LISP Zeilen hinbekommt käme auf die Idee diese in ein Befehlsscript zu packen.
Aber zu deiner Frage es ist wie CADmium geschrieben und du vermutest. Händisch oder LISP. 

------------------
Gruß Wolfgang

Andreas Kraus

Beiträge: 1193 / 1

WIN 10
ACAD 2017

Kommentarlos

Code:
(if (= (type
(setq satz (ssget "_X" '((0 . "TEXT,MTEXT") (410 . "Model"))))
      )
      'PICKSET
    )
  (mapcar '(lambda (ent_name)
    (vla-put-StyleName
      (vlax-ename->vla-object ent_name)
      "isocp-1"
    )
  )
  (vl-remove-if-not
    '(lambda (dummy) (= (type dummy) 'ENAME))
    (mapcar 'cadr (ssnamex satz))
  )
  )
)

------------------
Geht nicht, gibts nicht

Gruß
Andreas

http://kraus-cad.de

Manuel486

Beiträge: 92 / 0

Windows 10 Pro - 64-Bit -
Lenovo Thinkstation P520 -
Intel Xeon W-2255 CPU @ 3.70 GHz 10 Kerne -
2x32GB DDR4 RAM @ 2933 MHz -
Samsung MZVLB512HAJQ-000L7 SSD 500GB -
Seagate ST1000DM003 HDD 1000GB -
NVIDIA Quadro P2200 5GB -
Elgato Stream Deck 15 Tasten -
AutoCAD MEP 2019 - Revit 2018+2019+2020

(defun c:TXT2ISOCP1 (/)
(if (= (type
(setq satz (ssget "_X" '((0 . "TEXT,MTEXT") (410 . "Model"))))
      )
      'PICKSET
    )
  (mapcar '(lambda (ent_name)
    (vla-put-StyleName
      (vlax-ename->vla-object ent_name)
      "isocp-1"
    )
  )
  (vl-remove-if-not
    '(lambda (dummy) (= (type dummy) 'ENAME))
    (mapcar 'cadr (ssnamex satz))
  )
  )
)

So hab ich die LISP abgelegt.

In Autocad zeigt er das hier an:
Befehl: (Load "c:/cad/faust/_LISP/Alle Texte auf ISOCP1")
Falsch formatierte Liste in Eingabe
Befehl: TXT2ISOCP1
Unbekannter Befehl "TXT2ISOCP1". Drücken Sie F1-Taste für Hilfe.

Meldin

Beiträge: 336 / 0

ACA2018
Windows10

Ja dann ist doch alles in Ordnung     
Weil Acad kann dea nicht verarbeiten.
1 Was ist mit einer Dateiendung z.B. .lsp
2 dein Pfad nicht mit / sondern mit \\
und dann teste nochmal ich hatte dir aber in einem anderen Beitrag schon geschrieben wie eine lsp geladen wird.

------------------
Gruß Wolfgang

Manuel486

Beiträge: 92 / 0

Windows 10 Pro - 64-Bit -
Lenovo Thinkstation P520 -
Intel Xeon W-2255 CPU @ 3.70 GHz 10 Kerne -
2x32GB DDR4 RAM @ 2933 MHz -
Samsung MZVLB512HAJQ-000L7 SSD 500GB -
Seagate ST1000DM003 HDD 1000GB -
NVIDIA Quadro P2200 5GB -
Elgato Stream Deck 15 Tasten -
AutoCAD MEP 2019 - Revit 2018+2019+2020

Ich krame dieses alte Thema nochmal aus.

Ich habe das Problem jetzt so gelöst.

Legt MTexte + Texte auf ISOCP1.scr:

Code:
;ISOCP-1 wird erstellt /
;Standard wird aktuell gestellt /
;Lädt die LISP: CHTEXT.lsp /
;Wählt alle MTexte im aktuellen Bereich der Zeichnung aus, wenn es welche gibt, wird Ursprung ausgeführt /
;Wählt alle Texte im aktuellen Bereich der Zeichnung aus, wenn es welche gibt, werden alle Texte auf Stil ISOCP1 und auf Breite 0.8 gelegt /
;
_.-STYLE ISOCP-1 isocp.shx 0 0.8 0 _No _No
_.TEXTSTYLE Standard
(load "G:/1000SONS/CAD/Faust/LISP/CHTEXT.lsp")
(if (ssget "_X" (list '(0 . "MTEXT")(cons 410 (getvar 'CTAB))))(progn (initcommandversion)(command "_.EXPLODE" "_P" "")))
(if (ssget "_X" (list '(0 . "TEXT")(cons 410 (getvar 'CTAB))))(command-s "_.SCRIPTCALL" "G:/1000SONS/CAD/Faust/SCRIPT/Scriptcall/Texte auf ISOCP1.scr"))


Texte auf ISOCP1.scr:
Code:
;;;Texte auf ISOCP1
;
;Legt alle Texte auf Stil ISOCP1 und auf Breite 0.8 /
;
CHT Vorher  Stil  ISOCP-1 Breite 0.8

In den meisten Fällen gibt es immer mehr als einen Text, jetzt hatte ich aber den seltenen Fall das nur 1 Text in der Zeichnung war.

Da ist mir dann aufgefallen, dass das Script nicht mehr durch läuft, weil sich die Abfrage ändert…

Bei einem Text fragt er direkt nach dem neuen Stilnamen.

Bei mehreren Texten kommt: „Einzeln/Liste/Stil wählen/<Neuer Stilname für alle Textobjekte>:“

Gibt es eine Möglichkeit bei der ssget Abfrage nach der Anzahl von gefundenen Objekten zu differenzieren?

Also im Prinzip
(if (ssget "_X" (list '(0 . "TEXT")(Anzahl <1)(cons 410 (getvar 'CTAB))))(command-s "_.SCRIPTCALL" "G:/1000SONS/CAD/Faust/SCRIPT/Scriptcall/Text auf ISOCP1.scr"))
(if (ssget "_X" (list '(0 . "TEXT")(Anzahl >1)(cons 410 (getvar 'CTAB))))(command-s "_.SCRIPTCALL" "G:/1000SONS/CAD/Faust/SCRIPT/Scriptcall/Texte auf ISOCP1.scr"))

Ich habe außerdem versucht die CHTEXT.lsp so abzuändern das die Abfrage
„Einzeln/Liste/Stil wählen/<Neuer Stilname für alle Textobjekte>:“
auch kommt wenn ich nur einen Text in der Auswahl habe.
Das ist dann aber doch nicht so Copy+Paste wie ich mir das vorgestellt hatte. 

Ich hätte diese Abfrage hier vermutet:

Code:
;;; Set the prompt string
(defun cht_SetPrompt ()
  (if (= typ "Stil")
    (progn
      (initget "Einzeln Liste Neu Wählen ")
      (setq nw (getkword (strcat "\nEinzeln/Liste/Stil wählen/<"
                                prmpt
                                " für alle Textobjekte" ">: ")))
      (if (or (= nw "") (= nw nil) (= nw "Enter"))
        (setq nw (getstring (strcat prmpt
                                    " für alle Textobjekte" ": ")))
      )
    )
    (progn
      (initget "Liste Einzeln " 1)
      (setq nw (getreal (strcat "\nEinzeln/Liste/<"
                                prmpt
                                " für alle Textobjekte" ">: ")))
    )
  )
)

Vielleicht gibt es ja auch eine abgeänderte CHTEXT.lsp V2.01 
Ich habe V1.00 und V2.00, vielleicht gibt es auch eine V3.00, habe aber nichts gefunden.

cadffm

Beiträge: 20117 / 1053

System: F1
und Google

Zitat:
Original erstellt von Manuel486:
Vielleicht gibt es ja auch eine abgeänderte CHTEXT.lsp V2.01  
Ich habe V1.00 und V2.00, vielleicht gibt es auch eine V3.00, habe aber nichts gefunden.

Keine Ahnung 


>>"Gibt es eine Möglichkeit bei der ssget Abfrage nach der Anzahl von gefundenen Objekten zu differenzieren?"

Die Lispfunktion IF ist dir ja bereits bekannt,
die Anzahl der Objekte in einem Auswahlsatz erhälst du mit SSLENGTH [F1],
allerdings muss man dann noch ein wenig mehr tippen.

Beispiele

Code:
(and
  (ssget "_X")
  (if (= 1 (sslength (ssget "_P")))
      (alert "Nur ein Objekt gewählt")
      (alert "Mehrere Objekte gewählt")
  )
)


(if (setq aws (ssget "_X"))
  (if (= 1 (sslength aws))
      (alert "Nur ein Objekt gewählt")
      (alert "Mehrere Objekte gewählt")
  )
)


(if (setq aws (ssget "_X"))
  (cond
      ((= 1 (sslength aws))
        (alert "Nur ein Objekt gewählt"))
      ((= 2 (sslength aws))
        (alert "Zwei Objekte gewählt"))
      (t (alert "Viele Objekte gewählt"))
  )
)



Manuel486

Beiträge: 92 / 0

Windows 10 Pro - 64-Bit -
Lenovo Thinkstation P520 -
Intel Xeon W-2255 CPU @ 3.70 GHz 10 Kerne -
2x32GB DDR4 RAM @ 2933 MHz -
Samsung MZVLB512HAJQ-000L7 SSD 500GB -
Seagate ST1000DM003 HDD 1000GB -
NVIDIA Quadro P2200 5GB -
Elgato Stream Deck 15 Tasten -
AutoCAD MEP 2019 - Revit 2018+2019+2020

Habe es hin bekommen 

Code:
(if (setq aws (ssget "_X" (list '(0 . "TEXT")(cons 410 (getvar 'CTAB)))))
  (if (= 1 (sslength aws))
      (command-s "_.SCRIPTCALL" "G:/1000SONS/CAD/Faust/SCRIPT/SCRIPTCALL/Text auf ISOCP1.scr")
      (command-s "_.SCRIPTCALL" "G:/1000SONS/CAD/Faust/SCRIPT/SCRIPTCALL/Texte auf ISOCP1.scr")
  )
)

Ich tue mich immer noch schwer wieviel Klammern ich ans Ende setzten muss. 

Was ich nicht nachvollziehen kann...
Wie weis das Lisp in welcher Klammer ein Objekt und wo mehrere Objekte sind.

cadffm

Beiträge: 20117 / 1053

System: F1
und Google

>>Ich tue mich immer noch schwer wieviel Klammern ich ans Ende setzten muss. 

Klar, das liegt aber nicht an der Klammern, denn: Genau so viele Klammern wie "geöffnet" wurden.
Die Kunst ist eher die Platzierung der Klammern, dafür muß man wissen was in einer Klammer gehört.
Da einige Funktionen eine variable Anzahl an Argumenten/Parametern erlauben ist das nicht pauschal zu beantworten.

Fangen wir doch mit demselben Beispiel an welches das dir bekannte Tutorial nimmt,
die Lispfunktion PLUS, oder besser: '+
Lispfunktion + in der Hilfe erklärt [F1]

Man kann dort sehen: KEIN, EIN oder MEHRERE Argumente sind zulässig
(+)
(+ 3)
(+ 3 4)
(+ 3 4 5)
(+ 3 4 (+ 4 5))
(+ (+ 4 5) 6 7)
(+ 1 (+ 3 4 (+ 4 5)))

Die Lispfunktion ABS hingegen
will GENAU EIN Argument haben
Befehl: (abs)
; Fehler: Zu wenig Argumente

Befehl: (abs -1 -3)
; Fehler: Zu viele Argumente

Befehl: (abs -5)
5


Deswegen ist das Tutorial auch so gut, da wird einem sowas erklärt und genau auf
diesem Basiswissen bauen auch die größten und kompliziertesten Programme auf.
Welche Argumente und Parameter usw., steht in der Hilfe als Nachschlagwerk,
wie man damit umgeht lernt man mit der Zeit, in und nach dem Tutorial.

_

Schön formatiert fällt es schon etwas leichter die Orientierung zu behalten.
siehe Anhang


>>Was ich nicht nachvollziehen kann...
>>Wie weis das Lisp in welcher Klammer ein Objekt und wo mehrere Objekte sind.